"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class BamHeaderMachine(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "machines",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import metrics as metrics_1_2_2

        return {
            "machines": metrics_1_2_2.Machine,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_7_11 import metrics as metrics_1_2_2

        return {
            "org.gel.models.report.avro.Machine": metrics_1_2_2.Machine,
            "org.gel.models.report.avro.BamHeaderMachine": metrics_1_2_2.BamHeaderMachine,
        }

    __slots__ = [
        "machines",
    ]

    def __init__(
        self,
        machines,
        validate=None,
        **kwargs
    ):
        """Initialise the metrics_1_2_2.BamHeaderMachine model.

        :param machines:
        :type machines: list[Machine]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.2.2"
